
package com.loit.component.keygen.leaf.zk;

import com.loit.component.keygen.leaf.core.listener.DataChangedEventListener;
import com.loit.component.keygen.leaf.core.reg.RegistryCenter;
import com.loit.component.keygen.leaf.core.reg.RegistryCenterConfiguration;
import lombok.Getter;
import lombok.Setter;

import java.util.*;
import java.util.concurrent.locks.ReentrantLock;

public final class ThirdTestRegistryCenter implements RegistryCenter {
    
    private final Map<String, String> keys = new HashMap<>();
    
    @Getter
    @Setter
    private Properties properties = new Properties();

    private ReentrantLock lock = new ReentrantLock();
    
    @Override
    public void init(final RegistryCenterConfiguration config) {
    }
    
    @Override
    public String get(final String key) {
        return "";
    }

    @Override
    public String getDirectly(final String key) {
        return keys.get(key);
    }

    @Override
    public boolean isExisted(final String key) {
        return keys.containsKey(key);
    }
    
    @Override
    public List<String> getChildrenKeys(final String key) {
        return Collections.emptyList();
    }

    @Override
    public void persist(final String key, final String value) {
        keys.put(key, value);
    }

    @Override
    public void update(final String key, final String value) {
        keys.put(key, value);
    }
    
    @Override
    public void persistEphemeral(final String key, final String value) {
    }
    
    @Override
    public void watch(final String key, final DataChangedEventListener dataChangedEventListener) {
    }
    
    @Override
    public void close() {
    }
    
    @Override
    public String getType() {
        return "ThirdTestRegistryCenter";
    }

    @Override
    public void initLock(final String key) {
        lock = new ReentrantLock();
    }

    @Override
    public boolean tryLock() {
        return lock.tryLock();
    }

    @Override
    public void tryRelease() {
        lock.unlock();
    }
}
